// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from soccer_object_msgs:msg/Goalpost.idl
// generated code does not contain a copyright notice
#include "soccer_object_msgs/msg/detail/goalpost__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `point`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
soccer_object_msgs__msg__Goalpost__init(soccer_object_msgs__msg__Goalpost * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    soccer_object_msgs__msg__Goalpost__fini(msg);
    return false;
  }
  // observed_top
  // point
  if (!geometry_msgs__msg__Point__init(&msg->point)) {
    soccer_object_msgs__msg__Goalpost__fini(msg);
    return false;
  }
  return true;
}

void
soccer_object_msgs__msg__Goalpost__fini(soccer_object_msgs__msg__Goalpost * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // observed_top
  // point
  geometry_msgs__msg__Point__fini(&msg->point);
}

bool
soccer_object_msgs__msg__Goalpost__are_equal(const soccer_object_msgs__msg__Goalpost * lhs, const soccer_object_msgs__msg__Goalpost * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // observed_top
  if (lhs->observed_top != rhs->observed_top) {
    return false;
  }
  // point
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->point), &(rhs->point)))
  {
    return false;
  }
  return true;
}

bool
soccer_object_msgs__msg__Goalpost__copy(
  const soccer_object_msgs__msg__Goalpost * input,
  soccer_object_msgs__msg__Goalpost * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // observed_top
  output->observed_top = input->observed_top;
  // point
  if (!geometry_msgs__msg__Point__copy(
      &(input->point), &(output->point)))
  {
    return false;
  }
  return true;
}

soccer_object_msgs__msg__Goalpost *
soccer_object_msgs__msg__Goalpost__create()
{
  soccer_object_msgs__msg__Goalpost * msg = (soccer_object_msgs__msg__Goalpost *)malloc(sizeof(soccer_object_msgs__msg__Goalpost));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(soccer_object_msgs__msg__Goalpost));
  bool success = soccer_object_msgs__msg__Goalpost__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
soccer_object_msgs__msg__Goalpost__destroy(soccer_object_msgs__msg__Goalpost * msg)
{
  if (msg) {
    soccer_object_msgs__msg__Goalpost__fini(msg);
  }
  free(msg);
}


bool
soccer_object_msgs__msg__Goalpost__Sequence__init(soccer_object_msgs__msg__Goalpost__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  soccer_object_msgs__msg__Goalpost * data = NULL;
  if (size) {
    data = (soccer_object_msgs__msg__Goalpost *)calloc(size, sizeof(soccer_object_msgs__msg__Goalpost));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = soccer_object_msgs__msg__Goalpost__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        soccer_object_msgs__msg__Goalpost__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
soccer_object_msgs__msg__Goalpost__Sequence__fini(soccer_object_msgs__msg__Goalpost__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      soccer_object_msgs__msg__Goalpost__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

soccer_object_msgs__msg__Goalpost__Sequence *
soccer_object_msgs__msg__Goalpost__Sequence__create(size_t size)
{
  soccer_object_msgs__msg__Goalpost__Sequence * array = (soccer_object_msgs__msg__Goalpost__Sequence *)malloc(sizeof(soccer_object_msgs__msg__Goalpost__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = soccer_object_msgs__msg__Goalpost__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
soccer_object_msgs__msg__Goalpost__Sequence__destroy(soccer_object_msgs__msg__Goalpost__Sequence * array)
{
  if (array) {
    soccer_object_msgs__msg__Goalpost__Sequence__fini(array);
  }
  free(array);
}

bool
soccer_object_msgs__msg__Goalpost__Sequence__are_equal(const soccer_object_msgs__msg__Goalpost__Sequence * lhs, const soccer_object_msgs__msg__Goalpost__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!soccer_object_msgs__msg__Goalpost__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
soccer_object_msgs__msg__Goalpost__Sequence__copy(
  const soccer_object_msgs__msg__Goalpost__Sequence * input,
  soccer_object_msgs__msg__Goalpost__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(soccer_object_msgs__msg__Goalpost);
    soccer_object_msgs__msg__Goalpost * data =
      (soccer_object_msgs__msg__Goalpost *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!soccer_object_msgs__msg__Goalpost__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          soccer_object_msgs__msg__Goalpost__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!soccer_object_msgs__msg__Goalpost__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
