// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from soccer_object_msgs:msg/FieldLine.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__STRUCT_HPP_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'start'
// Member 'end'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__soccer_object_msgs__msg__FieldLine __attribute__((deprecated))
#else
# define DEPRECATED__soccer_object_msgs__msg__FieldLine __declspec(deprecated)
#endif

namespace soccer_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FieldLine_
{
  using Type = FieldLine_<ContainerAllocator>;

  explicit FieldLine_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    start(_init),
    end(_init)
  {
    (void)_init;
  }

  explicit FieldLine_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    start(_alloc, _init),
    end(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _start_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _start_type start;
  using _end_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _end_type end;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__start(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__end(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->end = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    soccer_object_msgs::msg::FieldLine_<ContainerAllocator> *;
  using ConstRawPtr =
    const soccer_object_msgs::msg::FieldLine_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      soccer_object_msgs::msg::FieldLine_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      soccer_object_msgs::msg::FieldLine_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__soccer_object_msgs__msg__FieldLine
    std::shared_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__soccer_object_msgs__msg__FieldLine
    std::shared_ptr<soccer_object_msgs::msg::FieldLine_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FieldLine_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->start != other.start) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    return true;
  }
  bool operator!=(const FieldLine_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FieldLine_

// alias to use template instance with default allocator
using FieldLine =
  soccer_object_msgs::msg::FieldLine_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace soccer_object_msgs

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__STRUCT_HPP_
