// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from soccer_object_msgs:msg/GoalpostArray.idl
// generated code does not contain a copyright notice
#include "soccer_object_msgs/msg/detail/goalpost_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `posts`
#include "soccer_object_msgs/msg/detail/goalpost__functions.h"

bool
soccer_object_msgs__msg__GoalpostArray__init(soccer_object_msgs__msg__GoalpostArray * msg)
{
  if (!msg) {
    return false;
  }
  // posts
  if (!soccer_object_msgs__msg__Goalpost__Sequence__init(&msg->posts, 0)) {
    soccer_object_msgs__msg__GoalpostArray__fini(msg);
    return false;
  }
  return true;
}

void
soccer_object_msgs__msg__GoalpostArray__fini(soccer_object_msgs__msg__GoalpostArray * msg)
{
  if (!msg) {
    return;
  }
  // posts
  soccer_object_msgs__msg__Goalpost__Sequence__fini(&msg->posts);
}

bool
soccer_object_msgs__msg__GoalpostArray__are_equal(const soccer_object_msgs__msg__GoalpostArray * lhs, const soccer_object_msgs__msg__GoalpostArray * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // posts
  if (!soccer_object_msgs__msg__Goalpost__Sequence__are_equal(
      &(lhs->posts), &(rhs->posts)))
  {
    return false;
  }
  return true;
}

bool
soccer_object_msgs__msg__GoalpostArray__copy(
  const soccer_object_msgs__msg__GoalpostArray * input,
  soccer_object_msgs__msg__GoalpostArray * output)
{
  if (!input || !output) {
    return false;
  }
  // posts
  if (!soccer_object_msgs__msg__Goalpost__Sequence__copy(
      &(input->posts), &(output->posts)))
  {
    return false;
  }
  return true;
}

soccer_object_msgs__msg__GoalpostArray *
soccer_object_msgs__msg__GoalpostArray__create()
{
  soccer_object_msgs__msg__GoalpostArray * msg = (soccer_object_msgs__msg__GoalpostArray *)malloc(sizeof(soccer_object_msgs__msg__GoalpostArray));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(soccer_object_msgs__msg__GoalpostArray));
  bool success = soccer_object_msgs__msg__GoalpostArray__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
soccer_object_msgs__msg__GoalpostArray__destroy(soccer_object_msgs__msg__GoalpostArray * msg)
{
  if (msg) {
    soccer_object_msgs__msg__GoalpostArray__fini(msg);
  }
  free(msg);
}


bool
soccer_object_msgs__msg__GoalpostArray__Sequence__init(soccer_object_msgs__msg__GoalpostArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  soccer_object_msgs__msg__GoalpostArray * data = NULL;
  if (size) {
    data = (soccer_object_msgs__msg__GoalpostArray *)calloc(size, sizeof(soccer_object_msgs__msg__GoalpostArray));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = soccer_object_msgs__msg__GoalpostArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        soccer_object_msgs__msg__GoalpostArray__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
soccer_object_msgs__msg__GoalpostArray__Sequence__fini(soccer_object_msgs__msg__GoalpostArray__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      soccer_object_msgs__msg__GoalpostArray__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

soccer_object_msgs__msg__GoalpostArray__Sequence *
soccer_object_msgs__msg__GoalpostArray__Sequence__create(size_t size)
{
  soccer_object_msgs__msg__GoalpostArray__Sequence * array = (soccer_object_msgs__msg__GoalpostArray__Sequence *)malloc(sizeof(soccer_object_msgs__msg__GoalpostArray__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = soccer_object_msgs__msg__GoalpostArray__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
soccer_object_msgs__msg__GoalpostArray__Sequence__destroy(soccer_object_msgs__msg__GoalpostArray__Sequence * array)
{
  if (array) {
    soccer_object_msgs__msg__GoalpostArray__Sequence__fini(array);
  }
  free(array);
}

bool
soccer_object_msgs__msg__GoalpostArray__Sequence__are_equal(const soccer_object_msgs__msg__GoalpostArray__Sequence * lhs, const soccer_object_msgs__msg__GoalpostArray__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!soccer_object_msgs__msg__GoalpostArray__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
soccer_object_msgs__msg__GoalpostArray__Sequence__copy(
  const soccer_object_msgs__msg__GoalpostArray__Sequence * input,
  soccer_object_msgs__msg__GoalpostArray__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(soccer_object_msgs__msg__GoalpostArray);
    soccer_object_msgs__msg__GoalpostArray * data =
      (soccer_object_msgs__msg__GoalpostArray *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!soccer_object_msgs__msg__GoalpostArray__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          soccer_object_msgs__msg__GoalpostArray__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!soccer_object_msgs__msg__GoalpostArray__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
