// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from soccer_object_msgs:msg/Robot.idl
// generated code does not contain a copyright notice
#include "soccer_object_msgs/msg/detail/robot__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `head`
#include "geometry_msgs/msg/detail/point__functions.h"
// Member `team`
#include "rosidl_runtime_c/string_functions.h"

bool
soccer_object_msgs__msg__Robot__init(soccer_object_msgs__msg__Robot * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    soccer_object_msgs__msg__Robot__fini(msg);
    return false;
  }
  // head
  if (!geometry_msgs__msg__Point__init(&msg->head)) {
    soccer_object_msgs__msg__Robot__fini(msg);
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__init(&msg->team)) {
    soccer_object_msgs__msg__Robot__fini(msg);
    return false;
  }
  // id
  return true;
}

void
soccer_object_msgs__msg__Robot__fini(soccer_object_msgs__msg__Robot * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // head
  geometry_msgs__msg__Point__fini(&msg->head);
  // team
  rosidl_runtime_c__String__fini(&msg->team);
  // id
}

bool
soccer_object_msgs__msg__Robot__are_equal(const soccer_object_msgs__msg__Robot * lhs, const soccer_object_msgs__msg__Robot * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // head
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->head), &(rhs->head)))
  {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->team), &(rhs->team)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  return true;
}

bool
soccer_object_msgs__msg__Robot__copy(
  const soccer_object_msgs__msg__Robot * input,
  soccer_object_msgs__msg__Robot * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // head
  if (!geometry_msgs__msg__Point__copy(
      &(input->head), &(output->head)))
  {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__copy(
      &(input->team), &(output->team)))
  {
    return false;
  }
  // id
  output->id = input->id;
  return true;
}

soccer_object_msgs__msg__Robot *
soccer_object_msgs__msg__Robot__create()
{
  soccer_object_msgs__msg__Robot * msg = (soccer_object_msgs__msg__Robot *)malloc(sizeof(soccer_object_msgs__msg__Robot));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(soccer_object_msgs__msg__Robot));
  bool success = soccer_object_msgs__msg__Robot__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
soccer_object_msgs__msg__Robot__destroy(soccer_object_msgs__msg__Robot * msg)
{
  if (msg) {
    soccer_object_msgs__msg__Robot__fini(msg);
  }
  free(msg);
}


bool
soccer_object_msgs__msg__Robot__Sequence__init(soccer_object_msgs__msg__Robot__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  soccer_object_msgs__msg__Robot * data = NULL;
  if (size) {
    data = (soccer_object_msgs__msg__Robot *)calloc(size, sizeof(soccer_object_msgs__msg__Robot));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = soccer_object_msgs__msg__Robot__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        soccer_object_msgs__msg__Robot__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
soccer_object_msgs__msg__Robot__Sequence__fini(soccer_object_msgs__msg__Robot__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      soccer_object_msgs__msg__Robot__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

soccer_object_msgs__msg__Robot__Sequence *
soccer_object_msgs__msg__Robot__Sequence__create(size_t size)
{
  soccer_object_msgs__msg__Robot__Sequence * array = (soccer_object_msgs__msg__Robot__Sequence *)malloc(sizeof(soccer_object_msgs__msg__Robot__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = soccer_object_msgs__msg__Robot__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
soccer_object_msgs__msg__Robot__Sequence__destroy(soccer_object_msgs__msg__Robot__Sequence * array)
{
  if (array) {
    soccer_object_msgs__msg__Robot__Sequence__fini(array);
  }
  free(array);
}

bool
soccer_object_msgs__msg__Robot__Sequence__are_equal(const soccer_object_msgs__msg__Robot__Sequence * lhs, const soccer_object_msgs__msg__Robot__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!soccer_object_msgs__msg__Robot__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
soccer_object_msgs__msg__Robot__Sequence__copy(
  const soccer_object_msgs__msg__Robot__Sequence * input,
  soccer_object_msgs__msg__Robot__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(soccer_object_msgs__msg__Robot);
    soccer_object_msgs__msg__Robot * data =
      (soccer_object_msgs__msg__Robot *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!soccer_object_msgs__msg__Robot__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          soccer_object_msgs__msg__Robot__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!soccer_object_msgs__msg__Robot__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
